'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var VroomAuthLogin = function (_Component) {
    _inherits(VroomAuthLogin, _Component);

    function VroomAuthLogin(props) {
        _classCallCheck(this, VroomAuthLogin);

        var _this = _possibleConstructorReturn(this, (VroomAuthLogin.__proto__ || Object.getPrototypeOf(VroomAuthLogin)).call(this, props));

        _this.signIn = _this.signIn.bind(_this);
        _this.state = {
            disabled: true
        };
        return _this;
    }

    _createClass(VroomAuthLogin, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            var _props = this.props,
                clientId = _props.clientId,
                cookiePolicy = _props.cookiePolicy,
                loginHint = _props.loginHint,
                hostedDomain = _props.hostedDomain,
                autoLoad = _props.autoLoad,
                fetchBasicProfile = _props.fetchBasicProfile,
                redirectUri = _props.redirectUri,
                discoveryDocs = _props.discoveryDocs,
                onFailure = _props.onFailure,
                uiMode = _props.uiMode;

            (function (doc, tag, id, callback) {
                var element = doc.getElementsByTagName(tag)[0];
                var fjs = element;
                var js = element;
                js = doc.createElement(tag);
                js.id = id;
                js.src = '//apis.google.com/js/api:client.js';
                fjs.parentNode.insertBefore(js, fjs);
                js.onload = callback;
            })(document, 'script', 'google-login', function () {
                var params = {
                    client_id: clientId,
                    cookiepolicy: cookiePolicy,
                    login_hint: loginHint,
                    hosted_domain: hostedDomain,
                    fetch_basic_profile: fetchBasicProfile,
                    discoveryDocs: discoveryDocs,
                    ui_mode: uiMode,
                    redirect_uri: redirectUri
                };
                window.gapi.load('auth2', function () {
                    _this2.setState({
                        disabled: false
                    });
                    if (!window.gapi.auth2.getAuthInstance()) {
                        window.gapi.auth2.init(params).then(function (res) {
                            if (isSignedIn && res.isSignedIn.get()) {
                                _this2._handleSigninSuccess(res.currentUser.get());
                            }
                        }, function (err) {
                            return onFailure(err);
                        });
                    }
                    if (autoLoad) {
                        _this2.signIn();
                    }
                });
            });
        }
    }, {
        key: 'signIn',
        value: function signIn(e) {
            var _this3 = this;

            if (e) {
                e.preventDefault();
            }
            if (!this.state.disabled) {
                var auth2 = window.gapi.auth2.getAuthInstance();
                var _props2 = this.props,
                    redirectUri = _props2.redirectUri,
                    onSuccess = _props2.onSuccess,
                    onRequest = _props2.onRequest,
                    fetchBasicProfile = _props2.fetchBasicProfile,
                    onFailure = _props2.onFailure,
                    prompt = _props2.prompt,
                    scope = _props2.scope,
                    offlineMode = _props2.offlineMode;

                var options = {
                    offline_mode: offlineMode,
                    redirect_uri: redirectUri,
                    fetch_basic_profile: fetchBasicProfile,
                    prompt: prompt,
                    scope: scope
                };
                onRequest();
                if (offlineMode) {
                    auth2.grantOfflineAccess(options).then(function (res) {
                        return onSuccess(res);
                    }, function (err) {
                        return onFailure(err);
                    });
                } else {
                    auth2.signIn(options).then(function (res) {
                        return _this3._handleSigninSuccess(res);
                    }, function (err) {
                        return onFailure(err);
                    });
                }
            }
        }
    }, {
        key: '_handleSigninSuccess',
        value: function _handleSigninSuccess(res) {
            var basicProfile = res.getBasicProfile();
            var authResponse = res.getAuthResponse();
            res.googleId = basicProfile.getId();
            res.tokenObj = authResponse;
            res.tokenId = authResponse.id_token;
            res.accessToken = authResponse.access_token;
            res.profileObj = {
                googleId: basicProfile.getId(),
                imageUrl: basicProfile.getImageUrl(),
                email: basicProfile.getEmail(),
                name: basicProfile.getName(),
                givenName: basicProfile.getGivenName(),
                familyName: basicProfile.getFamilyName()
            };
            this.props.onSuccess(res);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                tag = _props3.tag,
                style = _props3.style,
                className = _props3.className,
                disabledStyle = _props3.disabledStyle,
                buttonText = _props3.buttonText,
                children = _props3.children;

            var disabled = this.state.disabled || this.props.disabled;
            var initialStyle = {
                display: 'inline-block',
                background: '#ffffff',
                color: '#4097D3',
                width: 190,
                paddingTop: 10,
                paddingBottom: 10,
                borderRadius: 2,
                border: '1px solid gainsboro',
                fontSize: 16,
                fontWeight: 'bold',
                fontFamily: 'BlinkMacSystemFont, -apple-system, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", "Helvetica", "Arial", sans-serif'
            };
            var styleProp = function () {
                if (style) {
                    return style;
                } else if (className && !style) {
                    return {};
                }
                return initialStyle;
            }();
            var defaultStyle = function () {
                if (disabled) {
                    return Object.assign({}, styleProp, disabledStyle);
                }
                return styleProp;
            }();
            var vroomAuthLoginButton = _react2.default.createElement(tag, {
                onClick: this.signIn,
                style: defaultStyle,
                disabled: disabled,
                className: className
            }, children ? children : buttonText);
            return vroomAuthLoginButton;
        }
    }]);

    return VroomAuthLogin;
}(_react.Component);

VroomAuthLogin.propTypes = {
    onSuccess: _propTypes2.default.func.isRequired,
    onFailure: _propTypes2.default.func.isRequired,
    clientId: _propTypes2.default.string.isRequired,
    onRequest: _propTypes2.default.func,
    buttonText: _propTypes2.default.string,
    scope: _propTypes2.default.string,
    className: _propTypes2.default.string,
    redirectUri: _propTypes2.default.string,
    cookiePolicy: _propTypes2.default.string,
    loginHint: _propTypes2.default.string,
    hostedDomain: _propTypes2.default.string,
    children: _propTypes2.default.node,
    style: _propTypes2.default.object,
    disabledStyle: _propTypes2.default.object,
    fetchBasicProfile: _propTypes2.default.bool,
    prompt: _propTypes2.default.string,
    tag: _propTypes2.default.string,
    autoLoad: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    discoveryDocs: _propTypes2.default.array,
    offlineMode: _propTypes2.default.bool,
    uiMode: _propTypes2.default.string,
    isSignedIn: _propTypes2.default.bool
};

VroomAuthLogin.defaultProps = {
    isSignedIn: false,
    tag: 'button',
    buttonText: 'Sign In with Google',
    scope: 'profile email',
    offlineMode: false,
    prompt: '',
    hostedDomain: 'vroom.com',
    cookiePolicy: 'single_host_origin',
    fetchBasicProfile: true,
    uiMode: 'popup',
    disabledStyle: {
        opacity: 0.5
    },
    onRequest: function onRequest() {}
};

exports.default = VroomAuthLogin;